/**
 * This file is part of GenomeView, a genome browser and annotation curator
 * 
 * Copyright (C) 2007-2017 Thomas Abeel and contributors
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 * Project: http://genomeview.org/
 */
package net.sf.jannot.alignment.maf;

import java.util.ArrayList;
import java.util.Iterator;

import net.sf.jannot.Location;

/**
 * @author Thomas Abeel
 * 
 */
public class MemoryAlignmentBlock extends AbstractAlignmentBlock {

	public MemoryAlignmentBlock(int start, int end) {
		super(start, end);
	}

	private ArrayList<AbstractAlignmentSequence> list = new ArrayList<AbstractAlignmentSequence>();
	/**
	 * 
	 */
	private static final long serialVersionUID = -8021564812568122679L;

	@Override
	public void add(AbstractAlignmentSequence as) {
		// if (list.size() == 0) {
		// //this.loc = new Location(as.start(), as.end());
		// initPosition(as);
		// }
		list.add(as);
	}

	/**
	 * @param entry
	 */
	@Override
	public AbstractAlignmentSequence getAlignmentSequence(int i) {
		return list.get(i);

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Iterable#iterator()
	 */
	@Override
	public Iterator<AbstractAlignmentSequence> iterator() {
		return list.iterator();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see net.sf.jannot.alignment.maf.AbstractAlignmentBlock#size()
	 */
	@Override
	public int size() {
		return list.size();
	}

}
