/**
 * This file is part of GenomeView, a genome browser and annotation curator
 * 
 * Copyright (C) 2007-2017 Thomas Abeel and contributors
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see http://www.gnu.org/licenses/.
 *
 * Project: http://genomeview.org/
 */
package net.sf.jannot.source;

import java.io.InputStream;

import net.sf.jannot.EntrySet;
import net.sf.jannot.exception.ReadFailedException;
import net.sf.jannot.parser.Parser;

/**
 * Extends DataSource. 
 * 
 * Contains methods to read  
 * 
 * @author Thomas Abeel
 *
 */
public abstract class AbstractStreamDataSource extends DataSource {
    private Parser parser;

    private InputStream ios;

    public final void setParser(Parser parser) {
        this.parser = parser;
    }

    public final void setIos(InputStream ios) {
        this.ios = ios;
    }

    protected AbstractStreamDataSource(Locator l) {
super(l);
    }

    /**
     * 
     */
    @Override
    public EntrySet read(EntrySet set) throws ReadFailedException {
       return parser.parse(ios,set);
     

    }

    public InputStream getIos(){
    	return ios;
    }
    
    public Parser getParser() {
        return parser;
    }
}
